﻿using System;
using System.Linq.Expressions;

namespace Pellared.Utils
{
    public class Argument<T> : IArgument<T>
    {
        public Argument(T value, string name)
        {
            Value = value;
            Name = name;
        }

        public Argument(Expression<Func<T>> argumentExpression)
        {
            if (argumentExpression == null)
                throw new ArgumentNullException("argumentExpression");

            Value = argumentExpression.Compile()();
            Name = ExpressionUtils.GetName(argumentExpression);
        }

        public T Value { get; private set; }
        public string Name { get; private set; }

        public static implicit operator T(Argument<T> arg)
        {
            return arg.Value;
        }
    }
}